<template>
  <div class="catalogue" :class="{ 'open-item': maxHeight != '0px' }">
    <h3 :class="{ active: maxHeight != '0px' }" @click="toggleContent">
      {{ heading }}
    </h3>
    <div
      ref="content"
      :style="styleContent"
      class="catalogue__list"
      :class="{ show: maxHeight != '0px' }"
    >
      <slot />
    </div>
  </div>
</template>

<script>
export default {
  name: 'Collapse',
  props: {
    heading: {
      type: String,
      default: '',
    },
    open: {
      default: false,
      type: Boolean,
    },
    disabled: {
      default: false,
      type: Boolean,
    },
    sst: {
      default: false,
      type: Boolean,
    },
  },
  data() {
    return {
      maxHeight: '0px',
      dataReady: false,
    }
  },
  mounted() {
    window.addEventListener('resize', this.changeHeight)
    const maxHeightx = this.$refs.content.scrollHeight
    if (this.open) {
      this.maxHeight = `${maxHeightx}px`
    }
  },
  methods: {
    changeHeight() {
      const maxHeightx = this.$refs.content.scrollHeight
      if (this.maxHeight !== '0px') {
        this.maxHeight = `${maxHeightx}px`
      }
    },
    toggleContent() {
      if (this.sst && !this.dataReady) {
        this.$emit('fetch', {
          done: () => {
            this.initMaxHeight()
            this.dataReady = true
          },
        })
      } else {
        this.initMaxHeight()
      }
    },
    initMaxHeight() {
      const maxHeightx = this.$refs.content.scrollHeight
      if (this.maxHeight === '0px') {
        this.maxHeight = `${maxHeightx}px`
      } else {
        this.maxHeight = `0px`
      }
    },
  },
}
</script>
